# Infrastructure template

## Terraform

The following variables are supported:

### General options
- `TF_IN_AUTOMATION`: turn non-interactive mode (default: **1**)
- `TF_ROOT`: location of the main Terraform configuration (default: **terraform**)
- `TF_INIT_FLAGS`: specify further CLI argument for 'init' (default is blank)
### Debug options
- `TF_LOG`: Terraform built-in environment variable ([more information](https://developer.hashicorp.com/terraform/internals/debugging))
- `DEBUG_OUTPUT`: print bash commands that are being run in the gitlab-terraform commands (default: **false**)
### Plan options
- `TF_BACKEND_FLAGS`: specify backend config for 'init' (space separated, default is blank, e.g. **storage=A state=B**)
- `TF_FLAGS`: specify further CLI arguments for 'plan' and 'destroy' (default is blank)
- `TF_VAR_FILES`: specify var files (space separated, default is blank, e.g. **a.tfvars b.tfvars**)
- `TF_NOT_DELETE`: avoid deletion of any Terraform resources if there are some in the plan (default: **false**)
### Apply options
- `TF_AUTO_DEPLOY`: automatic trigger of 'apply' job (default: **false**)
- `TF_FORCE_DEPLOY`: force the creation of the 'apply' job even if the pipeline is not a merge request type (default: **false**)
- `TF_DESTROY`: enable 'destroy' job (default: **false** on main.yaml, **true** on standalone template)

## Vault

Variables supported:
- `VAULT_ADDR`: vault URL address (default: **https://vault.svc.builder.ai/** from the Gitlab parent group)
- `VAULT_SECRET`: secret object key (mandatory to specify)
